Докер-образы QHB и QCP
======================

Создание образов
----------------

Потребуется [docker-compose](https://docs.docker.com/compose/install/).

Как правило, не требуется вручную создавать образ, т.к. он автоматически создаётся при первом запуске. 

Однако это можно сделать и явным образом. 

```
$ docker-compose build
```

> **Внимание!** \
>*Здесь и далее, запускать `docker-compose` следует из-под обычного пользователя (не root).*
>*Возможно, для этого надо будет выполнить рекомендации [по настройке docker](https://docs.docker.com/engine/security/rootless/)*

> **Замечание.** \
>Если возникают проблемы с построением образа, связанные с недоступностью репозитория centos,
>нужно проверить сетевые разрешения. Иногда, перед построением, просто помогает выполнение таких команд:
>
>```
>sudo firewall-cmd --zone=public --add-masquerade --permanent
>sudo firewall-cmd --reload
>```

Запуск контейнера
-----------------

Для запуска контейнеров QHB и QCP с настройками по умолчанию, выполните в
текущей директории

```
$ docker-compose up
```

Прервать выполнение можно с помощью `Ctrl+C`, или же выполнив из другой консоли
в текущей директории `docker-compose down`.

Для запуска контейнеров в режиме "демона", выполните

```
$ docker-compose up -d
```

При первом запуске база данных будет автоматически инициализирована.

Посмотреть логи можно с помощью команды

```
$ docker-compose logs
```

По умолчанию, база данных сохраняется на диске в директории `qhb/pgdata`.


Остановка контейнеров
---------------------

Если контейнеры были запущен посредством `docker-compose up`, то для остановки
достаточно нажать `Ctrl+C`. Если же контейнеры был запущены в режиме "демона",
т.е. посредством `docker-compose up -d`, то для остановки контейнеров выполните
(из любой консоли) в текущей директории

```
$ docker-compose down
```

Эту команду также можно выполнять и при остановленных контейнерах.


Настройка QCP
=============

По умолчанию, сервис QCP отключён. \
Для его запуска необходимо убрать (закомментировать) запись

`entrypoint: ["echo", "Service qcp disabled"]` из раздела `services:` -> `qcp:`

а также настроить сервис, в частности, параметры подключения к серверу


Настройка QCP осуществляется посредством редактирования файла `./qcp/config.yaml`.

Обязательно замените в разделе `servers:` 

`%USER%` - на имя пользователя, от имени которого запускается `docker-compose`, \
и 

`%DATABASE%` - на имя базы данных, в простейшем случае база создается с именем, совпадающим с именем пользователя.
В дальнейшем, если вы создадите другую базу данных, этот параметр может потребоваться изменить.

По умолчанию сервис QCP работает на порту 8080, при необходимости переопределите этот параметр.

Обратите внимание, что настройки применяются только при запуске.


Запуск QHB с существующей базой
===============================

Отредактируйте файл `docker-compose.yaml` следующим образом:

1. В разделе 
    
    `services:` -> `qhb:` -> `volumes:` 
    
    замените 
    
    `- ./qhb/pgdata:/qhb-data/` 
    
    на 
    
    `- /path/to/pgdata:/qhb-data/`, 
    
    где
   `/path/to/pgdata` — абсолютный путь до директории "pgdata" с существующей
   базой данных.
   
2. В разделе 

    `services:` -> `qhb:` -> `environment:` 
    
    замените 
    
    `- USER` 
    
    на 
    
    `- USER=USERNAME` 
    
    Запустите контейнер с помощью команды 
    
    `docker-compose -e USER="USERNAME" up`, 
    
    где `USERNAME` — имя пользователя, владеющего директорией `/path/to/pgdata`.

Пример отредактированного файла `docker-compose.yaml`:

```yaml
version: "3.3"
services:
  qhb:
    build: qhb
    image: qhb
    network_mode: "host"
    environment:
      - USER=pguser
    volumes:
      - /path/to/pgdata:/qhb-data/

```

### Дополнительно

Установочные пакеты QHB можно скачать из репозитория QHB по адресу - [QHB repo](https://repo.quantom.info/qhb/std-1/centos/7/x86_64/)


